// Copyright by Uri Siman, IAPT - 1999, Delphi 4 unit.
unit Pro;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Forms, Dialogs,
  QuickRpt, QRCtrls, QRPrntr, Printers;

const Siz = 50; //max count fields in row
      SizY = 40; //max (band) height of page in Pixels/ab1

type
   TOnPrintEvent = procedure(Sender : TObject; var Value : String) of object;
   TAfterPrintEvent = procedure(sender: TQRCustomBand; BandPrinted : Boolean) of object;
   TRepBeforePrintEvent = procedure(Sender: TCustomQuickRep; var PrintReport: Boolean) of object;
   TRepAfterPreview = procedure(Sender: TObject) of object;


   SendPageWordOn = Class
    OldCall : Array[0..Siz*5] of TOnPrintEvent;
    PrnBand : Array[0..Siz*5] of TAfterPrintEvent;
   end;

type
  TWordTable = class (TPersistent)
   private
    FTableAutoFormat : Word;
    FTableAutoFit : Boolean;
    FTableRealWidth : Boolean;
    FDetailToTable : Boolean;
    FDetailMultyRows : Boolean;
    FTitleToTable : Boolean;
    FPageHeaderToTable : Boolean;
    FPageFooterToTable : Boolean;
    FGroupHeaderToTable : Boolean;
    FGroupFooterToTable : Boolean;
    FSubDetailToTable : Boolean;
    FColumnHeaderToTable : Boolean;
    FOverlayToTable : Boolean;
    FSummaryToTable : Boolean;
    FChildToTable : Boolean;
 published
    property TableAutoFormat : Word read FTableAutoFormat write FTableAutoFormat default 16;
    property TableAutoFit : Boolean read FTableAutoFit write FTableAutoFit;
    property TableRealWidth : Boolean read FTableRealWidth write FTableRealWidth;
    property DetailToTable : Boolean read FDetailToTable write FDetailToTable;
    property DetailMultyRows : Boolean read FDetailMultyRows write FDetailMultyRows;
    property TitleToTable : Boolean read FTitleToTable write FTitleToTable;
    property PageHeaderToTable : Boolean read FPageHeaderToTable write FPageHeaderToTable;
    property PageFooterToTable : Boolean read FPageFooterToTable write FPageFooterToTable;
    property GroupHeaderToTable : Boolean read FGroupHeaderToTable write FGroupHeaderToTable;
    property GroupFooterToTable : Boolean read FGroupFooterToTable write FGroupFooterToTable;
    property SubDetailToTable : Boolean read FSubDetailToTable write FSubDetailToTable;
    property ColumnHeaderToTable : Boolean read FColumnHeaderToTable write FColumnHeaderToTable;
    property OverlayToTable : Boolean read FOverlayToTable write FOverlayToTable;
    property SummaryToTable : Boolean read FSummaryToTable write FSummaryToTable;
    property ChildToTable : Boolean read FChildToTable write FChildToTable;
  end;

type
  TWordParams = class (TPersistent)
   private
    FIgnorePageHeader : Boolean;
    FIgnorePageFooter : Boolean;
    FTopMargin : Word;
    FBottomMargin : Word;
    FLeftMargin : Word;
    FRightMargin : Word;
    FLineSpacing : String;
    FFileName : String;
    FAutoClose : Boolean;
    FScaleFontSize : Integer;
    FHeaderDistance : String;
    FFooterDistance : String;
    FFontNameTabs : TFontName;
    FFontSizeTabs : Word;
   published
    property IgnorePageHeader : Boolean read FIgnorePageHeader write FIgnorePageHeader;
    property IgnorePageFooter : Boolean read FIgnorePageFooter write FIgnorePageFooter;
    property TopMargin : Word read FTopMargin write FTopMargin default 25;
    property BottomMargin : Word read FBottomMargin write FBottomMargin default 25;
    property LeftMargin : Word read FLeftMargin write FLeftMargin default 25;
    property RightMargin : Word read FRightMargin write FRightMargin default 25;
    property LineSpacing : String read FLineSpacing write FLineSpacing;
    property FileName : String read FFileName write FFileName;
    property AutoClose : Boolean read FAutoClose write FAutoClose;
    property ScaleFontSize : Integer read FScaleFontSize write FScaleFontSize default 0;
    property HeaderDistance : String read FHeaderDistance write FHeaderDistance;
    property FooterDistance : String read FFooterDistance write FFooterDistance;
    property FontNameTabs : TFontName read FFontNameTabs write FFontNameTabs;
    property FontSizeTabs : Word read FFontSizeTabs write FFontSizeTabs default 14;
  end;

type
  TTransferScale = class (TPersistent)
   private
    FTabA : Integer;
    FTabB : Integer;
    FMainA : Integer;
    FMainB : Integer;
   published
    property TabA : Integer read FTabA write FTabA default 32;
    property TabB : Integer read FTabB write FTabB default 33;
    property MainA : Integer read FMainA write FMainA default 1;
    property MainB : Integer read FMainB write FMainB default 1;
  end;

type
  TStencil = class (TPersistent)
   private
    FHorizontalSensitiv : Word;
    FVerticalSensitiv : Word;
   published
    property VerticalSensitiv : Word read FVerticalSensitiv write FVerticalSensitiv default 14;
    property HorizontalSensitiv : Word read FHorizontalSensitiv write FHorizontalSensitiv default 3;
  end;

type
  TTabBorders = class (TPersistent)
   private
    FBorderInside : Boolean;
    FBorderOutside : Boolean;
   published
    property BorderInside : Boolean read FBorderInside write FBorderInside;
    property BorderOutside : Boolean read FBorderOutside write FBorderOutside;
  end;

type
  TWordImages = class (TPersistent)
   private
     FEnabled : Boolean;
     FLeftPosCoef : double;
     FTopPosCoef : double;
     FEndPageLimit : Word;
     FStartPageLimit : Word;
     FTransparent : Boolean;
     FLock : Boolean;
     FWordWrap : Boolean;
   published
    property Enabled : Boolean read FEnabled write FEnabled;
    property LeftPosCoef : double read FLeftPosCoef write FLeftPosCoef;
    property TopPosCoef : double read FTopPosCoef write FTopPosCoef;
    property EndPageLimit : Word read FEndPageLimit write FEndPageLimit default 900;
    property StartPageLimit : Word read FStartPageLimit write FStartPageLimit default 30;
    property Transparent : Boolean read FTransparent write FTransparent;
    property Lock : Boolean read FLock write FLock;
    property WordWrap : Boolean read FWordWrap write FWordWrap;
  end;

type
  TWordRTF = class (TPersistent)
   private
     FEnabled : Boolean;
     FJustify : Boolean;
     FTextBox : Boolean;
     FRTFAsText : Boolean;
   published
    property Enabled : Boolean read FEnabled write FEnabled;
    property Justify : Boolean read FJustify write FJustify;
    property TextBox : Boolean read FTextBox write FTextBox;
    property RTFAsText : Boolean read FRTFAsText write FRTFAsText;
  end;

  TDRep = class(TComponent)
  private
    { Private declarations }
    FExecute : Boolean;
    FSeparator : Char;
    FShowExecute : Boolean;
    FWordImages : TWordImages;
    FWordRTF : TWordRTF;
    FWordTable : TWordTable;
    FWordParams : TWordParams;
    FTransferScale : TTransferScale;
    FStencil : TStencil;
    FTabBorders : TTabBorders;

  protected
    { Protected declarations }
  public
    { Public declarations }
    PageWordOn : SendPageWordOn;
    procedure QRLabel1Print(sender: TObject; var Value: string);
    procedure QRBand1AfterPrint(sender: TQRCustomBand; BandPrinted: Boolean);
    procedure APrint(sender : TObject);
    procedure BPrint(Sender: TCustomQuickRep; var PrintReport: Boolean);
    procedure Loaded; override;
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property Execute : Boolean read FExecute write FExecute;
    property ShowExecute : Boolean read FShowExecute write FShowExecute;
    property Separator : Char read FSeparator write FSeparator default #9;
    property WordImages : TWordImages read FWordImages write FWordImages;
    property WordRTF : TWordRTF read FWordRTF write FWordRTF;
    property WordTable : TWordTable read FWordTable write FWordTable;
    property WordParams : TWordParams read FWordParams write FWordParams;
    property TransferScale : TTransferScale read FTransferScale write FTransferScale;
    property Stencil : TStencil read FStencil write FStencil;
    property TabBorders : TTabBorders read FTabBorders write FTabBorders;
  end;

type
  TSortArray = array [1..Siz,1..3] of Integer;

var ExecuteToWord : Boolean;
    Bevent        : Boolean;
    tqr : TQuickRep;
     fm : TForm;
    Ab1 : Word; {14 : Vertical Sensitivity in Pixels}
    Ab2 : Word; {4 : Horizontal Sensitivity in Pixels, 3-optimal}
   WW,W : OleVariant;
 OldRef : Word;
  ShOld : Integer;
    Shp : Word;  //shapes counter
      T : TSortArray;
   MaxC : Word;

 // RefCnt : Word;


procedure Register;

Function PagePack(Y, L : Integer) : Word;
procedure MatSort(Sender : TQRCustomBand; Var M : TSortArray);

implementation
uses ActiveX, ComObj, ProSub, Controls, ClipBrd, TeEngine,
  Series, TeeProcs, Chart, DBChart, QrTee, comctrls;

Var
   BefPrn : TRepBeforePrintEvent;
   AftPrn : TRepAfterPreview;
       RE : TRichEdit;

constructor TDRep.Create(AOwner : TComponent);
begin
 inherited Create(AOwner);

 FStencil:=TStencil.Create;
 FWordImages:=TWordImages.Create;
 FWordRTF:=TWordRTF.Create;
 FWordTable:=TWordTable.Create;
 FWordParams:=TWordParams.Create;
 FTransferScale:=TTransferScale.Create;
 FTabBorders:=TTabBorders.Create;

 FSeparator:=#9;
 FShowExecute:= False;

 With FStencil Do
 Begin
  FVerticalSensitiv:= 14;
  FHorizontalSensitiv:= 4;
 end;

 With FWordImages Do
 Begin
  FEnabled:=True;
  FLeftPosCoef:= 0.75;
  FTopPosCoef:= 0.83;
  FEndPageLimit:=1000;
  FStartPageLimit:=30;
  FTransparent:=True;
  FLock:=False;
  FWordWrap:=False;
 end;

 With FWordRTF Do
 Begin
  FEnabled:=True;
  FJustify:=True;
  FTextBox:=True;
  FRTFAsText:=False;
 end;

 With FWordParams Do
 Begin
  FIgnorePageHeader:= True;
  FIgnorePageFooter:= True;
  FTopMargin:= 22;
  FBottomMargin:= 22;
  FLeftMargin:= 22;
  FRightMargin:= 22;
  FLineSpacing:= '1.3';
  FFileName:= 'RepWord';
  FAutoClose:= False;
  FScaleFontSize:= 0;
  FHeaderDistance:='1.5';
  FFooterDistance:='1.5';
  FFontNameTabs:='Arial';
  FFontSizeTabs:= 8;
 end;

 With FTransferScale Do
 Begin
  TabA:= 32;
  TabB:= 33;
  MainA:= 1;
  MainB:= 1;
 end;

 With FWordTable Do
 Begin
  FTableAutoFormat:=16;
  FDetailToTable:= False;
  FDetailMultyRows:= False;
  FTableAutoFit:= False;
  FTableRealWidth:= True;
  FTitleToTable:= False;
  FPageHeaderToTable:= False;
  FPageFooterToTable:= False;
  FGroupHeaderToTable:= False;
  FGroupFooterToTable:= False;
  FSubDetailToTable:= False;
  FColumnHeaderToTable:= False;
  FOverlayToTable:= False;
  FSummaryToTable:= False;
 end;

 With FTabBorders Do
 Begin
  FBorderInside:= True;
  FBorderOutSide:= True;
 end;

 ShOld:= FWordImages.FStartPageLimit;
// RefCnt :=0; //nothing row of tables before
 OldRef :=0; //nothing band before
 PrnPage :=0; //printed pages

end;

destructor TDRep.Destroy;
begin
// APrint(fm);
 ExecuteToWord:=FALSE;
 QRPrinter.CleanUp;
 FStencil.Free;
 FWordTable.Free;
 FWordImages.Free;
 FWordParams.Free;
 FTransferScale.Free;
 FTabBorders.Free;

 inherited Destroy;
end;

Function PagePack(Y, L : Integer) : Word;
Var I, J : Integer;
Begin
 For I:=0 to PageWord.Empty[Y]-1 Do
 If PageWord.Left[I, Y] >= L then
 Begin
   For J:=PageWord.Empty[Y] Downto I+1 Do
   Begin
    PageWord.WLine[J, Y]:= PageWord.WLine[J-1, Y];
    PageWord.Top[J, Y]:= PageWord.Top[J-1, Y];
    PageWord.Left[J, Y]:= PageWord.Left[J-1, Y];
    PageWord.Width[J, Y]:= PageWord.Width[J-1, Y];
    PageWord.FName[J, Y]:= PageWord.FName[J-1, Y];
    PageWord.FSize[J, Y]:= PageWord.FSize[J-1, Y];
    PageWord.FStyle[J, Y]:= PageWord.FStyle[J-1, Y];
   end;

   If PageWord.Empty[Y]<Siz then
      PageWord.Empty[Y]:=PageWord.Empty[Y]+1;
   Result:=I;
   Exit;
 end;

 If PageWord.Empty[Y]<Siz then
    PageWord.Empty[Y]:=PageWord.Empty[Y]+1;

 Result:=PageWord.Empty[Y] - 1;
end;

procedure MatSort(Sender : TQRCustomBand; Var M : TSortArray);
var A, B, I, J, K, L : Integer;
begin
   For I:=1 to siz Do
   Begin
    M[I,1]:= 0;
    M[I,2]:= 0; //zero matrix
    M[I,3]:= 0;
   end;
   J:=0;
   For I:=0 to TQRBand(sender).ControlCount-1 Do
   If (TQRBand(sender).Controls[I] Is TQRMemo) Or
      (TQRBand(sender).Controls[I] Is TQRRichText) Or
      (TQRBand(sender).Controls[I] Is TQRDBRichText) Or
      (TQRBand(sender).Controls[I] Is TQRChart) Or
      (TQRBand(sender).Controls[I] Is TQRImage) Or
      (TQRBand(sender).Controls[I] Is TQRDBImage) then
   Begin
    Inc(J); //saving top position in array
    If TQRBand(sender).Controls[I] Is TQRMemo then
    Begin
       M[J,1]:= TQRMemo(TQRBand(sender).Controls[I]).Top;
       M[J,3]:= 1;
    end;
    If TQRBand(sender).Controls[I] Is TQRRichText then
    Begin
       M[J,1]:= TQRRichText(TQRBand(sender).Controls[I]).Top;
       M[J,3]:= 2;
    end;
    If TQRBand(sender).Controls[I] Is TQRDBRichText then
    Begin
       M[J,1]:= TQRDBRichText(TQRBand(sender).Controls[I]).Top;
       M[J,3]:= 3;
    end;
    If TQRBand(sender).Controls[I] Is TQRChart then
    Begin
       M[J,1]:= TQRChart(TQRBand(sender).Controls[I]).Top;
       M[J,3]:= 4;
    end;
    If TQRBand(sender).Controls[I] Is TQRImage then
    Begin
       M[J,1]:= TQRImage(TQRBand(sender).Controls[I]).Top;
       M[J,3]:= 5;
    end;
    If TQRBand(sender).Controls[I] Is TQRDBImage then
    Begin
       M[J,1]:= TQRDBImage(TQRBand(sender).Controls[I]).Top;
       M[J,3]:= 6;
    end;
    M[J,2]:= I;
   end;
   //sorting for searching first controls in band
    K:=1;
   Repeat
    A:= M[K,1];
    B:= M[K,2];
    L:= M[K,3];
    For I:=K+1 to J Do
    If M[K,1]>M[I,1] then
    Begin
     A:= M[I,1];
     B:= M[I,2];
     L:= M[I,3];
     M[I,1]:= M[K,1];
     M[I,2]:= M[K,2];
     M[I,3]:= M[K,3];
     M[K,1]:= A;
     M[K,2]:= B;
     M[K,3]:= L;
    end;
    Inc(K);
   Until K+1>=J;
   MaxC:=J;
end;

procedure TDRep.QRLabel1Print(sender: TObject; var Value: string);
var // str : string;
   X, Y : Integer;
 //   Pix : Integer;
     Tg : LongInt;
begin

If Length(Value)<=0 then
If ((TQRBand((Sender As Tcontrol).Parent).BandType=rbTitle)
  And (FWordTable.FTitleToTable=True)) Or
   ((TQRBand((Sender As Tcontrol).Parent).BandType=rbDetail)
  And (FWordTable.FDetailToTable=True)) Or
   ((TQRBand((Sender As Tcontrol).Parent).BandType=rbPageHeader)
  And (FWordTable.FPageHeaderToTable=True)) Or
   ((TQRBand((Sender As Tcontrol).Parent).BandType=rbPageFooter)
  And (FWordTable.FPageFooterToTable=True)) Or
   ((TQRBand((Sender As Tcontrol).Parent).BandType=rbGroupHeader)
  And (FWordTable.FGroupHeaderToTable=True)) Or
   ((TQRBand((Sender As Tcontrol).Parent).BandType=rbGroupFooter)
  And (FWordTable.FGroupFooterToTable=True)) Or
   ((TQRBand((Sender As Tcontrol).Parent).BandType=rbSubDetail)
  And (FWordTable.FSubDetailToTable=True)) Or
   ((TQRBand((Sender As Tcontrol).Parent).BandType=rbColumnHeader)
  And (FWordTable.FColumnHeaderToTable=True)) Or
   ((TQRBand((Sender As Tcontrol).Parent).BandType=rbOverlay)
  And (FWordTable.FOverlayToTable=True)) Or
   ((TQRBand((Sender As Tcontrol).Parent).BandType=rbSummary)
  And (FWordTable.FSummaryToTable=True)) then
    Value:=' ';

 Case PageWord.Typ[(Sender As TComponent).Tag] of
 1: If Assigned(PageWordOn.OldCall[(Sender As TQRLabel).Tag]) then
    Begin
     {  ,  }
     (Sender As TQRLabel).OnPrint:=
                 PageWordOn.OldCall[(Sender As TQRLabel).Tag];
      Tg:=(Sender As TQRLabel).Tag; {  }
     (Sender As TQRLabel).Tag:= PageWord.OldTag[Tg];
     {  }
     (Sender As TQRLabel).Tag:=Tg;
     (Sender As TQRLabel).OnPrint(sender, Value);
    end;
 2: If Assigned(PageWordOn.OldCall[(Sender As TQRDBText).Tag]) then
    Begin
     {  ,  }
     (Sender As TQRDBText).OnPrint:=
                 PageWordOn.OldCall[(Sender As TQRDBText).Tag];
      Tg:=(Sender As TQRDBText).Tag; {  }
     (Sender As TQRDBText).Tag:= PageWord.OldTag[Tg];
     {  }
     (Sender As TQRDBText).Tag:=Tg;
     (Sender As TQRDBText).OnPrint(sender, Value);
    end;
 3: If Assigned(PageWordOn.OldCall[(Sender As TQRDBCalc).Tag]) then
    Begin
     {  ,  }
     (Sender As TQRDBCalc).OnPrint:=
                 PageWordOn.OldCall[(Sender As TQRDBCalc).Tag];
      Tg:=(Sender As TQRDBCalc).Tag; {  }
     (Sender As TQRDBCalc).Tag:= PageWord.OldTag[Tg];
     {  }
     (Sender As TQRDBCalc).Tag:=Tg;
     (Sender As TQRDBCalc).OnPrint(sender, Value);
    end;
 4: If Assigned(PageWordOn.OldCall[(Sender As TQRSysData).Tag]) then
    Begin
     {  ,  }
     (Sender As TQRSysData).OnPrint:=
                 PageWordOn.OldCall[(Sender As TQRSysData).Tag];
      Tg:=(Sender As TQRSysData).Tag; {  }
     (Sender As TQRSysData).Tag:= PageWord.OldTag[Tg];
     {  }
     (Sender As TQRSysData).Tag:=Tg;
     (Sender As TQRSysData).OnPrint(sender, Value);
    end;
 5: If Assigned(PageWordOn.OldCall[(Sender As TQRExpr).Tag]) then
    Begin
     {  ,  }
     (Sender As TQRExpr).OnPrint:=
                 PageWordOn.OldCall[(Sender As TQRExpr).Tag];
      Tg:=(Sender As TQRExpr).Tag; {  }
     (Sender As TQRExpr).Tag:= PageWord.OldTag[Tg];
     {  }
     (Sender As TQRExpr).Tag:=Tg;
     (Sender As TQRExpr).OnPrint(sender, Value);
    end;
  end;

  Ref:=PageWord.Band[(Sender As TComponent).Tag];

  If (Sender Is TQRLabel) then
  Begin
   {   }
   Y:= (Sender As TQRLabel).Top div Ab1;
   X:= (Sender As TQRLabel).Left div Ab2;
   PageWord.Name[(Sender As TComponent).Tag]:=
                 (Sender As TQRLabel).Name;

   X:=PagePack(Y, (Sender As TQRLabel).Left);

   PageWord.WLine[X, Y]:= Value;
   PageWord.Top[X, Y]:= (Sender As TQRLabel).Top;
   PageWord.Left[X, Y]:= (Sender As TQRLabel).Left;
   PageWord.Width[X, Y]:= (Sender As TQRLabel).Width;
   PageWord.FName[X, Y]:= (Sender As TQRLabel).Font.Name;
   PageWord.FSize[X, Y]:= (Sender As TQRLabel).Font.Size;
   PageWord.FStyle[X, Y]:= (Sender As TQRLabel).Font.Style;
   end;

  If (Sender Is TQRDBText) then
  Begin
   {   }
   Y:= (Sender As TQRDBText).Top div Ab1;
   X:= (Sender As TQRDBText).Left div Ab2;
   PageWord.Name[(Sender As TComponent).Tag]:=
                 (Sender As TQRDBText).Name;

   X:=PagePack(Y, (Sender As TQRDBText).Left);

   PageWord.WLine[X, Y]:= Value;
   PageWord.Top[X, Y]:= (Sender As TQRDBText).Top;
   PageWord.Left[X, Y]:= (Sender As TQRDBText).Left;
   PageWord.Width[X, Y]:= (Sender As TQRDBText).Width;
   PageWord.FName[X, Y]:= (Sender As TQRDBText).Font.Name;
   PageWord.FSize[X, Y]:= (Sender As TQRDBText).Font.Size;
   PageWord.FStyle[X, Y]:= (Sender As TQRDBText).Font.Style;
  end;

  If (Sender Is TQRDBCalc) then
  Begin
   {   }
   Y:= (Sender As TQRDBCalc).Top div Ab1;
   X:= (Sender As TQRDBCalc).Left div Ab2;
   PageWord.Name[(Sender As TComponent).Tag]:=
                 (Sender As TQRDBCalc).Name;

   X:=PagePack(Y, (Sender As TQRDBCalc).Left);

   PageWord.WLine[X, Y]:= Value;
   PageWord.Top[X, Y]:= (Sender As TQRDBCalc).Top;
   PageWord.Left[X, Y]:= (Sender As TQRDBCalc).Left;
   PageWord.Width[X, Y]:= (Sender As TQRDBCalc).Width;
   PageWord.FName[X, Y]:= (Sender As TQRDBCalc).Font.Name;
   PageWord.FSize[X, Y]:= (Sender As TQRDBCalc).Font.Size;
   PageWord.FStyle[X, Y]:= (Sender As TQRDBCalc).Font.Style;
   end;

  If (Sender Is TQRSysData) then
  Begin
   {   }
   Y:= (Sender As TQRSysData).Top div Ab1;
   X:= (Sender As TQRSysData).Left div Ab2;
   PageWord.Name[(Sender As TComponent).Tag]:=
                 (Sender As TQRSysData).Name;

   X:=PagePack(Y, (Sender As TQRSysData).Left);

   PageWord.WLine[X, Y]:= Value;
   PageWord.Top[X, Y]:= (Sender As TQRSysData).Top;
   PageWord.Left[X, Y]:= (Sender As TQRSysData).Left;
   PageWord.Width[X, Y]:= (Sender As TQRSysData).Width;
   PageWord.FName[X, Y]:= (Sender As TQRSysData).Font.Name;
   PageWord.FSize[X, Y]:= (Sender As TQRSysData).Font.Size;
   PageWord.FStyle[X, Y]:= (Sender As TQRSysData).Font.Style;
   end;

  If (Sender Is TQRExpr) then
  Begin
   {   }
   Y:= (Sender As TQRExpr).Top div Ab1;
   X:= (Sender As TQRExpr).Left div Ab2;
   PageWord.Name[(Sender As TComponent).Tag]:=
                 (Sender As TQRExpr).Name;

   X:=PagePack(Y, (Sender As TQRExpr).Left);

   PageWord.WLine[X, Y]:= Value;
   PageWord.Top[X, Y]:= (Sender As TQRExpr).Top;
   PageWord.Left[X, Y]:= (Sender As TQRExpr).Left;
   PageWord.Width[X, Y]:= (Sender As TQRExpr).Width;
   PageWord.FName[X, Y]:= (Sender As TQRExpr).Font.Name;
   PageWord.FSize[X, Y]:= (Sender As TQRExpr).Font.Size;
   PageWord.FStyle[X, Y]:= (Sender As TQRExpr).Font.Style;
   end;
  try
   RefW:=TQRBand((Sender As Tcontrol).Parent).Height;
  except
   RefW:=50000; //band not exist for this control
  end;
end;

procedure TDRep.QRBand1AfterPrint(sender: TQRCustomBand; BandPrinted: Boolean);
var    A, B, C, D, I : Integer;
       AFormat : Word;
         AData : THandle;
      APalette : HPALETTE;
           OKB : Boolean;
begin

   SubFTableRealWidth:=FWordTable.FTableRealWidth;
   SubFFontNameTabs:=FWordParams.FFontNameTabs;
   SubFScaleFontSize:=FWordParams.FScaleFontSize;
   SubFFontSizeTabs:=FWordParams.FFontSizeTabs;
   SubTabA:=FTransferScale.TabA;
   SubTabB:=FTransferScale.TabB;
   SubMainA:=FTransferScale.MainA;
   SubMainB:=FTransferScale.MainB;
   SubShowExecute:=FShowExecute;
   SubIgnorePageHeader:=FWordParams.FIgnorePageHeader;
   SubIgnorePageFooter:=FWordParams.FIgnorePageFooter;

   SubTableAutoFormat:=FWordTable.TableAutoFormat;
   SubFTitleToTable:=FWordTable.FTitleToTable;
   SubFDetailToTable:=FWordTable.FDetailToTable;
   SubFPageHeaderToTable:=FWordTable.FPageHeaderToTable;
   SubFPageFooterToTable:=FWordTable.FPageFooterToTable;
   SubFGroupHeaderToTable:=FWordTable.FGroupHeaderToTable;
   SubFGroupFooterToTable:=FWordTable.FGroupFooterToTable;
   SubFSubDetailToTable:=FWordTable.FSubDetailToTable;
   SubFColumnHeaderToTable:=FWordTable.FColumnHeaderToTable;
   SubFOverlayToTable:=FWordTable.FOverlayToTable;
   SubFSummaryToTable:=FWordTable.FSummaryToTable;
   SubFSeparator:=FSeparator;
   SubFTableRealWidth:=FWordTable.FTableRealWidth;
   SubFDetailMultyRows:=FWordTable.FDetailMultyRows;
   SubFTableAutoFit:=FWordTable.FTableAutoFit;
   SubBorderInside:=FTabBorders.BorderInside;
   SubBorderOutside:=FTabBorders.BorderOutside;
   SubFChildToTable:=FWordTable.FChildToTable;

   OnAftPrn; {calling transfer method}

   If FWordRTF.Enabled Or FWordImages.Enabled then
   Begin

   If FWordRTF.FTextBox then
    W.ParaUp
   else
    W.LineUp(MaxC, False);

    Shp:=1;
    MatSort(Sender, T);
    OKB:= True;
    SubTransparent:=FWordImages.FTransparent;
    SubLock:=FWordImages.FLock;
    SubWordWrap:=FWordImages.WordWrap;

   For I:=1 to MaxC Do
   Begin
   If T[I,3]=1 then //QRMemo
   If TQRMemo(TQRBand(sender).Controls[T[I,2]]).Enabled = True then
   Begin
    RE.Lines:=TQRMemo(TQRBand(sender).Controls[T[I,2]]).Lines;
    RE.SelectAll;
    RE.CopyToClipBoard;

    If Not FWordRTF.FTextBox then
    Begin
     W.InsertPara;
     W.Font(TQRMemo(TQRBand(sender).Controls[T[I,2]]).Font.Name,
            TQRMemo(TQRBand(sender).Controls[T[I,2]]).Font.Size);
     If fsBold in TQRMemo(TQRBand(sender).Controls[T[I,2]]).Font.Style then
        W.Bold(1);
     If fsItalic in TQRMemo(TQRBand(sender).Controls[T[I,2]]).Font.Style then
        W.Italic(1);
     If fsUnderline in TQRMemo(TQRBand(sender).Controls[T[I,2]]).Font.Style then
        W.Underline(1);
     If fsStrikeOut in TQRMemo(TQRBand(sender).Controls[T[I,2]]).Font.Style then
        W.Strikethrough(1);

    If FWordRTF.Justify then
    W.JustifyPara else
    If TQRMemo(TQRBand(sender).Controls[T[I,2]]).Alignment=taCenter then
    W.CenterPara  else
    If TQRMemo(TQRBand(sender).Controls[T[I,2]]).Alignment=taLeftJustify then
    W.LeftPara    else
    If TQRMemo(TQRBand(sender).Controls[T[I,2]]).Alignment=taRightJustify then
    W.RightPara;

    W.EditPaste;

   end
   else
   Begin

    A:= Round((TQRBand(sender).Left + TQRMemo(TQRBand(sender).Controls[T[I,2]]).Left)
         * FWordImages.FLeftPosCoef);
    If OKB then
    B:= Round((TQRMemo(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);

    If B + Round(FWordImages.FTopPosCoef * TQRMemo(TQRBand(sender).Controls[T[I,2]]).Height) >
       Round(FWordImages.FTopPosCoef * FWordImages.FEndPageLimit) then
    Begin
       ShOld:=ShOld mod (FWordImages.FEndPageLimit + FWordImages.FStartPageLimit);
       B:= Round((TQRMemo(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);
       OKB:= False;
    end;
    C:= Round(TQRMemo(TQRBand(sender).Controls[T[I,2]]).Height
            * FWordImages.FTopPosCoef);
    D:= Round(TQRMemo(TQRBand(sender).Controls[T[I,2]]).Width
         * FWordImages.FLeftPosCoef);

    MemoPrn(A, B, C, D);
    Inc(Shp);
    end;

   end;

   If T[I,3]=2 then  //QRRichText
   If TQRRichText(TQRBand(sender).Controls[T[I,2]]).Enabled = True then
   Begin
    RE.Lines:=TQRRichText(TQRBand(sender).Controls[T[I,2]]).Lines;
    RE.SelectAll;
    RE.CopyToClipBoard;

    If Not FWordRTF.FRTFAsText then
    Begin

    RichTextPrn(A, B, C, D, False);

   end
   else
   Begin

    A:= Round((TQRBand(sender).Left + TQRRichText(TQRBand(sender).Controls[T[I,2]]).Left)
         * FWordImages.FLeftPosCoef);
    If OKB then
    B:= Round((TQRRichText(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);

    If B + Round(FWordImages.FTopPosCoef * TQRRichText(TQRBand(sender).Controls[T[I,2]]).Height) >
       Round(FWordImages.FTopPosCoef * FWordImages.FEndPageLimit) then
    Begin
       ShOld:=ShOld mod (FWordImages.FEndPageLimit + FWordImages.FStartPageLimit);
       B:= Round((TQRRichText(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);
       OKB:= False;
    end;
    C:= Round(TQRRichText(TQRBand(sender).Controls[T[I,2]]).Height
            * FWordImages.FTopPosCoef);
    D:= Round(TQRRichText(TQRBand(sender).Controls[T[I,2]]).Width
         * FWordImages.FLeftPosCoef);

    RichTextPrn(A, B, C, D, True);
    Inc(Shp);
    end;

   end;

   If T[I,3]=3 then  //QRDBRichText
   If TQRDBRichText(TQRBand(sender).Controls[T[I,2]]).Enabled = True then
   Begin
    ClipBoard.Assign(TQRDBRichText(TQRBand(sender).Controls[T[I,2]]).
              DataSet.FieldByName(TQRDBRichText(TQRBand(sender).
              Controls[T[I,2]]).DataField));

    If Not FWordRTF.FRTFAsText then
    Begin

    RichTextPrn(A, B, C, D, False);

   end
   else
   Begin

    A:= Round((TQRBand(sender).Left + TQRDBRichText(TQRBand(sender).Controls[T[I,2]]).Left)
         * FWordImages.FLeftPosCoef);
    If OKB then
    B:= Round((TQRDBRichText(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);

    If B + Round(FWordImages.FTopPosCoef * TQRDBRichText(TQRBand(sender).Controls[T[I,2]]).Height) >
       Round(FWordImages.FTopPosCoef * FWordImages.FEndPageLimit) then
    Begin
       ShOld:=ShOld mod (FWordImages.FEndPageLimit + FWordImages.FStartPageLimit);
       B:= Round((TQRDBRichText(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);
       OKB:= False;
    end;
    C:= Round(TQRDBRichText(TQRBand(sender).Controls[T[I,2]]).Height
            * FWordImages.FTopPosCoef);
    D:= Round(TQRDBRichText(TQRBand(sender).Controls[T[I,2]]).Width
         * FWordImages.FLeftPosCoef);

    RichTextPrn(A, B, C, D, True);
    Inc(Shp);
    end;

   end;

   //*************************
   //searching for QRCharts and QRImages for transferring...

   If T[I,3]=4 then
   If TQRChart(TQRBand(sender).Controls[T[I,2]]).Enabled = True then
   Begin

    TQRChart(TQRBand(sender).Controls[T[I,2]]).Chart.CopyToClipboardMetafile(True);

    A:= Round((TQRBand(sender).Left + TQRChart(TQRBand(sender).Controls[T[I,2]]).Left)
         * FWordImages.FLeftPosCoef);
    If OKB then
    B:= Round((TQRChart(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);

    If B + Round(FWordImages.FTopPosCoef * TQRChart(TQRBand(sender).Controls[T[I,2]]).Height) >
       Round(FWordImages.FTopPosCoef * FWordImages.FEndPageLimit) then
    Begin
       ShOld:=ShOld mod (FWordImages.FEndPageLimit + FWordImages.FStartPageLimit);

    B:= Round((TQRChart(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);
       OKB:= False;
    end;
    ChartPrn(A, B, False);   //sending QRChart to MS Word
    Inc(Shp);
   end;

   If T[I,3]=5 then
   If TQRImage(TQRBand(sender).Controls[T[I,2]]).Enabled = True then
   Begin
    AFormat:= CF_METAFILEPICT;

    TQRImage(TQRBand(sender).Controls[T[I,2]]).Picture.Graphic.
                    SaveToClipboardFormat(AFormat, AData, APalette);

    ClipBoard.SetAsHandle(AFormat, AData);

    A:= Round((TQRBand(sender).Left + TQRImage(TQRBand(sender).Controls[T[I,2]]).Left)
         * FWordImages.FLeftPosCoef);
    If OKB then
    B:= Round((TQRImage(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);

    If B + Round(FWordImages.FTopPosCoef * TQRImage(TQRBand(sender).Controls[T[I,2]]).Height) >
       Round(FWordImages.FTopPosCoef * FWordImages.FEndPageLimit) then
    Begin
       ShOld:=ShOld mod (FWordImages.FEndPageLimit + FWordImages.FStartPageLimit);

    B:= Round((TQRImage(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);
       OKB:= False;
    end;
    ChartPrn(A, B, True);   //sending QRImage to MS Word
    Inc(Shp);
   end;

   If T[I,3]=6 then
   If TQRDBImage(TQRBand(sender).Controls[T[I,2]]).Enabled = True then
   Begin
    AFormat:= CF_METAFILEPICT;

    TQRDBImage(TQRBand(sender).Controls[T[I,2]]).Picture.Graphic.
                    SaveToClipboardFormat(AFormat, AData, APalette);

    ClipBoard.SetAsHandle(AFormat, AData);

    A:= Round((TQRBand(sender).Left + TQRDBImage(TQRBand(sender).Controls[T[I,2]]).Left)
         * FWordImages.FLeftPosCoef);
    If OKB then
    B:= Round((TQRDBImage(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);

    If B + Round(FWordImages.FTopPosCoef * TQRDBImage(TQRBand(sender).Controls[T[I,2]]).Height) >
       Round(FWordImages.FTopPosCoef * FWordImages.FEndPageLimit) then
    Begin
       ShOld:=ShOld mod (FWordImages.FEndPageLimit + FWordImages.FStartPageLimit);
    B:= Round((TQRDBImage(TQRBand(sender).Controls[T[I,2]]).Top + ShOld)
         * FWordImages.FTopPosCoef);
       OKB:= False;
    end;
    ChartPrn(A, B, True);   //sending QRDBImage to MS Word
    Inc(Shp);
   end;
{   OKB:=True;
   For I:=MShp to Shp Do
   Begin
    CurPage:= WW.ActiveDocument.BuiltInDocumentProperties.Item[14];
    If CurPage>SPage[I] then
    Begin
//     SStr:= SName[I];
     WW.ActiveDocument.Shapes(SName[I]).Select;
     WW.Selection.MoveUp(Unit:= 7,
                        Count:= CurPage - SPage[I],
                       Extend:= 0);
     WW.Selection.Collapse;
     OKB:=False;
    end;
   end;
    If OKB = True then MShp:=Shp; }
   end;

   W.ParaDown;

   end;

   ShOld:=ShOld + TQRBand(sender).Height;

end;


procedure TDRep.APrint(sender : TObject);
var   i : integer;
begin

 W.EndOfDocument;

 If FWordParams.FAutoClose then
 Begin
   W.FileSaveAs(Name := FWordParams.FFileName);
   W.AppClose;
 end
 else
 If Not FShowExecute then
 Begin
   W.AppShow;
   W.AppMaximize;
 end;

 I:=0;
 with fm do
 while (i<ComponentCount) do
 if (Components[i] is TQuickRep) then
 begin {  afterprint}
    (Components[i] As TQuickRep).AfterPreview:=AftPrn;
    If EXAP then
       (Components[i] As TQuickRep).AfterPreview(sender);
    Break;
 end
 else Inc(i);

end;


procedure TDRep.Loaded;
var frm : TComponent;
    i : Integer;
begin
 inherited Loaded;

 if Not(FExecute Or ExecuteToWord) then Exit;

 QRPrinter.CleanUp;
 Ab1:=FStencil.FVerticalSensitiv;
 Ab2:=FStencil.FHorizontalSensitiv;
 TM:= FWordParams.FTopMargin;
 BM:= FWordParams.FBottomMargin;
 LM:= FWordParams.FLeftMargin;
 RM:= FWordParams.FRightMargin;

 PageA3:=0;
 EXBP:=False;
 EXAP:=False;
 BEvent:=TRUE;
 frm:=Owner;
 while (not (frm is TForm)) do frm:=frm.Owner;
 fm:=TForm(frm);
 with fm do
 begin
//  I:=Canvas.TextWidth(' ');  {ArtiFact!!!!!!!! Without it not working !!!}
  I:=0;
  while (i<ComponentCount) do
    if (Components[i] is TQuickRep) then
     begin  {saving old calls}
      tqr:=TQuickRep(Components[i]);
      If Assigned((Components[i] as TQuickRep).BeforePrint) then
         EXBP:=True; {saving old call BeforePrint}
      If Assigned((Components[i] as TQuickRep).AfterPreview) then
         EXAP:=True; {saving old call AfterPreview}

      If Not (tqr.Page.Orientation = poPortrait) then
         PageA3:=1;

      AftPrn:=tqr.AfterPreview;
      BefPrn:=tqr.BeforePrint;
      tqr.BeforePrint:=BPrint;
      tqr.AfterPreview:=APrint;

      Break;
     end
    else Inc(i);
 end;
end;

procedure TDRep.BPrint(Sender: TCustomQuickRep; var PrintReport: Boolean);
Var I, J : Integer;
begin
 RE:=TRichEdit.Create(sender);
 RE.Parent:=TWinControl(sender);
 RE.Visible:=False;
 RE.WordWrap:=False;

  PrintReport:=True;
  I:=0;
  with fm do
  while (i<ComponentCount) do
  if (Components[i] is TQuickRep) then
  begin {  beforeprint}
    (Components[i] As TQuickRep).BeforePrint:=BefPrn;
    If EXBP then
       (Components[i] As TQuickRep).BeforePrint(sender, PrintReport);
    Break;
  end
  else Inc(i);

  if Not BEvent then exit;
  if  FExecute or ExecuteToWord then
  begin

   Ref:=0;
   L:=0;

  try
   CoInitialize(nil);
   W:=CreateOleObject('Word.Basic');
   WW := CreateOLEObject('Word.Application');
  except
   raise EOleError.Create('Sorry!.. Can`t create the Word !!!');
   Exit;
  end;


   W.AppShow;
   W.AppMinimize;

  If FShowExecute then
  Begin
//   W.AppShow;
   W.AppMaximize;
  end;

   PageWord:=SendPageWord.Create;
   PageWordOn:=SendPageWordOn.Create;

   W.FileNew;
   If PageA3 = 1 then W.TogglePortrait;
   W.FilePageSetup(TopMargin := TM,  BottomMargin := BM,
                  LeftMargin := LM, RightMargin := RM,
                  Orientation:= PageA3, ApplyPropsTo:=4,
                  HeaderDistance := FWordParams.FHeaderDistance,
                  FooterDistance := FWordParams.FFooterDistance);
   W.FormatParagraph(LineSpacingRule := 4,
                     LineSpacing := FWordParams.FLineSpacing);

   W.Font(FWordParams.FFontNameTabs, 8);

   J:=0;

   For I:=0 to fm.ComponentCount - 1 Do
   Begin
   If (fm.Components[I] Is TQRBand) then
   Begin   {   }
     PageWordOn.PrnBand[J]:=(fm.Components[I] As TQRBand).AfterPrint;
     (fm.Components[I] As TQRBand).AfterPrint:=QRBand1AfterPrint;
   end;
   If (fm.Components[I] Is TQRSubDetail) then
   Begin   {   }
     PageWordOn.PrnBand[J]:=(fm.Components[I] As TQRSubDetail).AfterPrint;
     (fm.Components[I] As TQRSubDetail).AfterPrint:=QRBand1AfterPrint;
   end;
   If (fm.Components[I] Is TQRChildBand) then
   Begin   {   }
     PageWordOn.PrnBand[J]:=(fm.Components[I] As TQRChildBand).AfterPrint;
     (fm.Components[I] As TQRChildBand).AfterPrint:=QRBand1AfterPrint;
   end;
   If (fm.Components[I] Is TQRGroup) then
   Begin   {   }
     PageWordOn.PrnBand[J]:=(fm.Components[I] As TQRGroup).AfterPrint;
     (fm.Components[I] As TQRGroup).AfterPrint:=QRBand1AfterPrint;
   end;

    If (fm.Components[I] Is TQRLabel) then
    Begin
     PageWord.OldTag[J]:=fm.Components[I].Tag;
     PageWord.Typ[J]:=1;
     If (fm.Components[I] As TQRLabel).Parent Is TQRBand then
     Case ((fm.Components[I] As TQRLabel).Parent As TQRBand).BandType of
      rbTitle        : PageWord.Band[J]:=1;
      rbDetail       : PageWord.Band[J]:=2;
      rbPageHeader   : PageWord.Band[J]:=3;
      rbPageFooter   : PageWord.Band[J]:=4;
      rbGroupHeader  : PageWord.Band[J]:=5;
      rbGroupFooter  : PageWord.Band[J]:=6;
      rbSubDetail    : PageWord.Band[J]:=7;
      rbColumnHeader : PageWord.Band[J]:=8;
      rbOverlay      : PageWord.Band[J]:=9;
      rbSummary      : PageWord.Band[J]:=10;
      rbChild        : PageWord.Band[J]:=11;
     else
      PageWord.Band[J]:=10;
     end
     else
      PageWord.Band[J]:=10;

     fm.Components[I].Tag:=J; {Labels}
     PageWordOn.OldCall[J]:=TQRLabel(fm.Components[I]).OnPrint;
     TQRLabel(fm.Components[I]).OnPrint:=QRLabel1Print;
     Inc(J);
    end;
    If (fm.Components[I] Is TQRDBText) then
    Begin
     PageWord.OldTag[J]:=fm.Components[I].Tag;
     PageWord.Typ[J]:=2;
     If (fm.Components[I] As TQRDBText).Parent Is TQRBand then
     Case ((fm.Components[I] As TQRDBText).Parent As TQRBand).BandType of
      rbTitle        : PageWord.Band[J]:=1;
      rbDetail       : PageWord.Band[J]:=2;
      rbPageHeader   : PageWord.Band[J]:=3;
      rbPageFooter   : PageWord.Band[J]:=4;
      rbGroupHeader  : PageWord.Band[J]:=5;
      rbGroupFooter  : PageWord.Band[J]:=6;
      rbSubDetail    : PageWord.Band[J]:=7;
      rbColumnHeader : PageWord.Band[J]:=8;
      rbOverlay      : PageWord.Band[J]:=9;
      rbSummary      : PageWord.Band[J]:=10;
      rbChild        : PageWord.Band[J]:=11;
     else
      PageWord.Band[J]:=10;
     end
     else
      PageWord.Band[J]:=10;

     fm.Components[I].Tag:=J; {DBTexts}
     PageWordOn.OldCall[J]:=TQRDBText(fm.Components[I]).OnPrint;
     TQRDBText(fm.Components[I]).OnPrint:=QRLabel1Print;
     Inc(J);
    end;
    If (fm.Components[I] Is TQRDBCalc) then
    Begin
     PageWord.OldTag[J]:=fm.Components[I].Tag;
     PageWord.Typ[J]:=3;
     If (fm.Components[I] As TQRDBCalc).Parent Is TQRBand then
     Case ((fm.Components[I] As TQRDBCalc).Parent As TQRBand).BandType of
      rbTitle        : PageWord.Band[J]:=1;
      rbDetail       : PageWord.Band[J]:=2;
      rbPageHeader   : PageWord.Band[J]:=3;
      rbPageFooter   : PageWord.Band[J]:=4;
      rbGroupHeader  : PageWord.Band[J]:=5;
      rbGroupFooter  : PageWord.Band[J]:=6;
      rbSubDetail    : PageWord.Band[J]:=7;
      rbColumnHeader : PageWord.Band[J]:=8;
      rbOverlay      : PageWord.Band[J]:=9;
      rbSummary      : PageWord.Band[J]:=10;
      rbChild        : PageWord.Band[J]:=11;
     else
      PageWord.Band[J]:=10;
     end
     else
      PageWord.Band[J]:=10;

     fm.Components[I].Tag:=J; {DBCalc}
     PageWordOn.OldCall[J]:=TQRDBCalc(fm.Components[I]).OnPrint;
     TQRDBCalc(fm.Components[I]).OnPrint:=QRLabel1Print;
     Inc(J);
    end;
    If (fm.Components[I] Is TQRSysData) then
    Begin
     PageWord.OldTag[J]:=fm.Components[I].Tag;
     PageWord.Typ[J]:=4;
     If (fm.Components[I] As TQRSysData).Parent Is TQRBand then
     Case ((fm.Components[I] As TQRSysData).Parent As TQRBand).BandType of
      rbTitle        : PageWord.Band[J]:=1;
      rbDetail       : PageWord.Band[J]:=2;
      rbPageHeader   : PageWord.Band[J]:=3;
      rbPageFooter   : PageWord.Band[J]:=4;
      rbGroupHeader  : PageWord.Band[J]:=5;
      rbGroupFooter  : PageWord.Band[J]:=6;
      rbSubDetail    : PageWord.Band[J]:=7;
      rbColumnHeader : PageWord.Band[J]:=8;
      rbOverlay      : PageWord.Band[J]:=9;
      rbSummary      : PageWord.Band[J]:=10;
      rbChild        : PageWord.Band[J]:=11;
     else
      PageWord.Band[J]:=10;
     end
     else
      PageWord.Band[J]:=10;

     fm.Components[I].Tag:=J; {SysData}
     PageWordOn.OldCall[J]:=TQRSysData(fm.Components[I]).OnPrint;
     TQRSysData(fm.Components[I]).OnPrint:=QRLabel1Print;
     Inc(J);
    end;
    If (fm.Components[I] Is TQRExpr) then
    Begin
     PageWord.OldTag[J]:=fm.Components[I].Tag;
     PageWord.Typ[J]:=5;
     If (fm.Components[I] As TQRExpr).Parent Is TQRBand then
     Case ((fm.Components[I] As TQRExpr).Parent As TQRBand).BandType of
      rbTitle        : PageWord.Band[J]:=1;
      rbDetail       : PageWord.Band[J]:=2;
      rbPageHeader   : PageWord.Band[J]:=3;
      rbPageFooter   : PageWord.Band[J]:=4;
      rbGroupHeader  : PageWord.Band[J]:=5;
      rbGroupFooter  : PageWord.Band[J]:=6;
      rbSubDetail    : PageWord.Band[J]:=7;
      rbColumnHeader : PageWord.Band[J]:=8;
      rbOverlay      : PageWord.Band[J]:=9;
      rbSummary      : PageWord.Band[J]:=10;
      rbChild        : PageWord.Band[J]:=11;
     else
      PageWord.Band[J]:=10;
     end
     else
      PageWord.Band[J]:=10;

     fm.Components[I].Tag:=J; {Expr}
     PageWordOn.OldCall[J]:=TQRExpr(fm.Components[I]).OnPrint;
     TQRExpr(fm.Components[I]).OnPrint:=QRLabel1Print;
     Inc(J);
    end;

   end;
  // i:=0;
  end;
end;

procedure Register;
begin
  RegisterComponents('QReport', [TDRep]);
end;

end.


